<?php
/*
Функции для zadanie.biz
Автор: Denvas
http://bmatrix.net/
*/
    
    //==================================================//
    /*
    Верх страницы
    */
    function data_header(){
        global $rescount, $user_agent, $template, $design_name, $wapver, $codehelp, $globalcontent, $endcode, $title, $titlepage;
        $globalcontent=array();
        setcookie("tu",time(),time()+30*24*60*60,"/");
		
		$globalcontent[TMPL."codeblock".TMPL]="";
        $globalcontent[TMPL."codeend".TMPL]=$endcode;
		$globalcontent[TMPL."crumbs".TMPL]="";
		$globalcontent[TMPL."title".TMPL]=$title;
		$globalcontent[TMPL."menu".TMPL]="";
		$globalcontent[TMPL."codeendmessage".TMPL]="";
		$globalcontent[TMPL."headmeta".TMPL]="";
        $codehelp="";
		$titlepage="";
        $template=InitDesign($design_name,$wapver);
        //убирать id для поисковиков
        if(((strpos($user_agent,"http://")!==false)||(strpos($user_agent,"Yandex")!==false))&&(isset($_GET["uid"]))){
            Relocation(QueryParam(array("uid")),"",-1);
        };
        $rescount=counter(1);
    };
    //==================================================//
    /*
    Низ страницы
    */
    function data_bottom($nametemplate="main",$align="left"){
        global $menuselect, $code, $codemenu, $title, $template, $endcode, $keyword, $wapver, $codehelp, $crumbs, $path_template, $globalcontent, $metadescription, $titlepage;

        if(empty($template[$nametemplate]))$nametemplate="main";
		//открытая зона
		$menuselect=array("mainfree"=>"free","mainindex"=>"free","mainlogin"=>"free","main"=>"free","mainmember"=>"member","mainadv"=>"adv","mainadmin"=>"admin");
		if((isset($menuselect[$nametemplate]))&&(file_exists("template/menu".$menuselect[$nametemplate].".txt"))){$codemenu=file_get_contents("template/menu".$menuselect[$nametemplate].".txt");};
		
        //вставка данных из файлов для основных шаблонов
        $repl=array();
        $valuetemp=$template[$nametemplate];
        while($str=getsubstr($valuetemp,TMPL."include:",TMPL,true)){
            if(strpos($str,".")!==false)continue;//файл не может содержать точку
            $data=file_get_contents($path_template."/".$str.".txt");
            $repl[TMPL."include:".$str.TMPL]=$data;
        };//while
        $valuetemp=strtr($template[$nametemplate],$repl);

        //хлебные крошки
        $codecrumbs="";
        $ncrumbs=count($crumbs);
        if($ncrumbs>1){
            $strdeep="";
            for($j=0;$j<$ncrumbs-1;$j++){
                $codecrumbs[]=strtr($template["crumbs_elem"],array(TMPL."url".TMPL=>$crumbs[$j][0],TMPL."code".TMPL=>$strdeep.$crumbs[$j][1]));
                $strdeep.=$template["crumbs_deep"];
            };
            $codecrumbs[]=strtr($template["crumbs_current"],array(TMPL."url".TMPL=>$crumbs[$ncrumbs-1][0],TMPL."code".TMPL=>$strdeep.$crumbs[$ncrumbs-1][1]));
            if(!empty($template["crumbs_reverse"]))$codecrumbs=array_reverse($codecrumbs);
            $codecrumbs=strtr($template["crumbs_main"],array(TMPL."code".TMPL=>join($template["crumbs_sep"],$codecrumbs)));
        };//if($ncrumbs>1)

        $repl=isset($globalcontent)?$globalcontent:array();
        $repl[TMPL."align".TMPL]=$align;
        $repl[TMPL."code".TMPL]=$code;
        $repl[TMPL."menu".TMPL]=$codemenu;
        $repl[TMPL."title".TMPL]=$title;
		$repl[TMPL."description".TMPL]=empty($metadescription)?$title:$metadescription;
        $repl[TMPL."banner".TMPL]="";
        $repl[TMPL."keywords".TMPL]=$keyword;
        $repl[TMPL."codehelp".TMPL]=$codehelp;
        $repl[TMPL."crumbs".TMPL]=$codecrumbs;
		$repl[TMPL."titlepage".TMPL]=$titlepage;
        $code=strtr($valuetemp,$repl);
    };
    //==================================================//
    /*
    получение всей информации о пользователе
    */
    function GetUserInfo(){
        global $user_agent, $ip;
        //регистрация сессии, если еще не зарегистрирована
        if((!empty($_GET["sid"]))&&(empty($_SESSION))){
            session_name("sid");
            session_start();
        };
        if((empty($_SESSION))||((!empty($_SESSION["user_agent"]))&&(strcmp($_SESSION["user_agent"],$user_agent)!=0))||((!empty($_SESSION["ip"]))&&(strcmp($_SESSION["ip"],$ip)!=0))||($_SESSION["timeupdate"]<time()-60*60)||(empty($_SESSION["__clientzadanie"]))){
            $_SESSION=array();
        }
        else{
            $_SESSION["timeupdate"]=time();
        };
        return $_SESSION;
    };
    //==================================================//
    //проверка на доступ
    function CheckAccess($auth){
        if(empty($auth["access"]))return 1;
        $url=strtr(strtr($_SERVER["REQUEST_URI"],array("/admin/"=>"/")),array("?"=>"|","&"=>"|","/"=>"|"));
        $url=explode("|",$url);
        $access=&$auth["access"];
        $naccess=count($access);
        for($j=0;$j<$naccess;$j++){
            $flag=true;
            $row=$access[$j][2];
            for($i=0;$i<count($row);$i++){
                if(!in_array($row[$i],$url)){
                    $flag=false;
                };
            };
            if($flag)return 1;
        };//for
        return 0;
    };
    //==================================================//
    /*
    проверка, не занесен ли ip в черный список
    */
    function ip_is_black($ip){
        global $path_data;
        $data=@file_get_contents($path_data."/ipblacklist.txt");
        if(empty($data))return false;
        if(strpos($data,$ip)!==false)return true;
        return false;
    }
    //==================================================//
    /*
    занесение в список забаненых ip
    */
    function ip_is_ban($ip){
        global $path_data;
        $data=@file_get_contents($path_data."/banip.txt");
        if(empty($data))return false;
        if(strpos($data,"|".$ip."|"))return true;
        return false;
    }
    //==================================================//
    /*
    занесение в список забанненых ip
    */
    function ip_to_ban($ip){
        global $path_data;
        $fd=fopen($path_data."/banip.txt","ab");
        if($fd){
            flock($fd,LOCK_EX);
            fwrite($fd,time()."|".$ip."|\n");
            fclose($fd);
        };
        return true;
    }
    //==================================================//
    function showcounter(){
        global $template;
        $res=counter();
        return strtr($template["counter"],array(TMPL."alluniq".TMPL=>$res["alluniq"],TMPL."allhits".TMPL=>$res["allhits"],TMPL."todayuniq".TMPL=>$res["todayuniq"],TMPL."todayhits".TMPL=>$res["todayhits"],TMPL."online".TMPL=>$res["online"],TMPL."membersonline".TMPL=>$res["membersonline"],TMPL."members".TMPL=>$res["members"],TMPL."yesterdayuniq".TMPL=>$res["yesterdayuniq"]));
    };
    //==================================================//
    /*
    Преобразование всех тэгов к нижнему регистру
    */
    function tag_lower(&$content){
        $content=preg_replace("/(\<(.*?)\s)/es","strtolower('\\1')",$content);
        $content=preg_replace("/(\<([^\s]*)\>)/es","strtolower('\\1')",$content);
    };
    //==================================================//
    /*
    Преобразование "текстовых" файлов в текстовые.
    */
    function file_totext(&$name,&$content){
        $dot=strrpos($name,".");
        $ext=substr($name,$dot+1);
        //преобразование имени файла
        if(strcmp($ext,"txt")!=0){
            $name=substr($name,0,$dot).".txt";
        };
        //преобразование контента
        if((stristr($content,"<html"))||(stristr($content,"<?xml"))){
            tag_lower($content);
            $strip="<a><img><b><u><i><small><big><br><hr><h1><h2><br/><hr/>";
            $content=strip_tags($content,$strip."<p>");
            $content=strtr($content,array("</p>"=>"<br/>","<br>"=>"<br/>","<hr>"=>"<hr/>"));
            $content=strip_tags($content,$strip);
            $content=strtr($content,array("<br/>"=>"\n","\r"=>""));
            $content=explode("\n",$content);
            $newcontent="";if(strlen($content[0])>30)$newcontent.="Заголовок\n";
            for($i=0;$i<count($content);$i++){
                $line=trim($content[$i]);
                if(empty($line))continue;
                $newcontent.=$line."\n";
            };//for
            $content=$newcontent;
       };//if(strcmp($ext,"txt")!=0)
    };//function totext_name
    //==================================================//
    /*
    Проход в глубину каталогов и генерация массива
    */
    function CategoryDeep($id_cat,$numd="",$deep=0){
        $code=array();$strshift="";if($deep>30)return array();
        for($i=0;$i<$deep;$i++)$strshift.="&nbsp;&nbsp;&nbsp;&nbsp;";
        $infoelem=array("elem"=>0,"text"=>0,"file"=>0,"cat"=>0,"form"=>0,"code"=>0);
        $shop=GetProduct($id_cat,0);$num=0;
        $nshop=count($shop);
        for($j=0;$j<$nshop;$j++){
            $data=&$shop[$j];
            if(strcmp($data["type"],"cat")==0){
                if($data["demo"]>1)continue;//невидимые ссылки вообще не обрабатывать
                $num++;
                $catinfodeep=CategoryDeep($data["id"],$numd.($numd?".":"").$num,$deep+1);
                $code[]=array_merge(array("info"=>$catinfodeep[1],"shift"=>$strshift,"num"=>$numd.($numd?".":"").$num,"parent"=>$id_cat),$data);
                if(!empty($catinfodeep[0]))$code=array_merge($code,$catinfodeep[0]);
            };
            $infoelem[$data["type"]]++;
            $infoelem["elem"]++;
        };//for($j=0;$j<$nshop;$j++)
        return array($code,$infoelem);
    };//function CategoryDeep
    //==================================================//
    /*
    Принимает: $dir - директория,
               $ext - расширение файлов
               $deep - глубина
    Действие: Считывает рекурсивно все каталоги
    Возвращает: дерево каталогов
    */
    function ReadDirRecursive($dir,$ext="",$deep=0){
        $dirs=array();
        $dir=rtrim($dir,"/ \n\r");
        $filesfind=array();
        $handle=opendir($dir);
        while ($file = readdir($handle)){
            if((strcmp($file,'.')==0)||(strcmp($file,'..')==0))continue;
            if(is_dir($dir."/".$file)){
                $dirs[]=$dir."/".$file;
                if(empty($ext))$filesfind[]=array($dir,$file,0);
            }
            else{
                if(empty($ext)||(stristr($file,$ext)))$filesfind[]=array($dir,$file,1);
            };
        };//while ($file = readdir($handle))
        closedir($handle);
        for($i=0;$i<count($dirs);$i++){
            $filesfind=array_merge($filesfind,ReadDirRecursive($dirs[$i],$ext,$deep+1));
        };
        return $filesfind;
    };//function readdirrecursive($dir)
    //==================================================//
    /*
    Запись файла с поддержкой выхода в случае демоверсии
    */
    function SaveFile($filename,$content,$flag="wb"){
        $fd=fopen($filename,$flag);
        if(!$fd)return false;
        flock($fd,LOCK_EX);
        fwrite($fd,$content);fclose($fd);
        chmod($filename,0666);
        return true;
    };
    //==================================================//
    /*
    проверка и дополнение профиля
    */
    function CheckProfile($id_user,$ip,$agent){
        $filename="users/".(500*(int)($id_user/500))."/".$id_user."/profile.txt";
        if(empty($agent))$agent="not";
        if(file_exists($filename)){
            $data=file_get_contents($filename);
        }
        else{
            $data="";
        };
        if((strpos($data,$ip)!==false)&&(strpos($data,$agent)!==false)){
            return 1;
        };
        $fd=fopen($filename,"ab");
		if($fd){
	        fwrite($fd,time()."|".$ip."|".$agent."|\n");
	        fclose($fd);
		};
        return 0;
    };
    //==================================================//
	/*
	Выводит список модулей
	*/
	function ShowModules($membermodules,$lines=true,$pathmenu=""){
		global $template, $auth, $namecurrency, $currentmenu;
		$urlsep=QueryParam(array("menustatus"));
		if((isset($_SESSION["id_user"]))&&(isset($_SESSION["hiddenmenu"]))&&(isset($_GET["menustatus"]))){
			$elem=explode(".",$_GET["menustatus"]);
			if(!empty($membermodules[$elem[0]])){
				$_SESSION["hiddenmenu"]=trim(strtr($_SESSION["hiddenmenu"],array(";".$elem[0].";"=>";")),";");
				if(empty($elem[1]))$_SESSION["hiddenmenu"].=";".$elem[0].";";
				$_SESSION["hiddenmenu"]=";".trim($_SESSION["hiddenmenu"],";").";";
				SQLquery("update users set hiddenmenu='".AddSlashes($_SESSION["hiddenmenu"])."' where id_user=".(int)$_SESSION["id_user"]);
			};
			Relocation($urlsep,empty($elem[1])?"Раздел '".$membermodules[$elem[0]][1]."' скрыт":"Раздел '".$membermodules[$elem[0]][1]."' развернут",-1);
		};
		$code="";$codeend="";
		$currentmenu="!start";
        reset($membermodules);$i=0;
		$lenpath=substr_count($pathmenu,"/");
        while(list($keymenu,$valmenu)=each($membermodules)){
			if(($pathmenu)&&((strpos($keymenu,$pathmenu)!==0)||(strcmp($keymenu,$pathmenu)==0)))continue;			
			$keytest=rtrim($keymenu,"/");
			$lenkey=substr_count($keytest,"/");
			if($lenkey>$lenpath)continue;
			
            if(strpos($keymenu,"_")!==false){
                $group=substr($keymenu,0,strpos($keymenu,"_"));
                if(strpos($auth["ext"],$group)===false)continue;
            };
            if(empty($valmenu[0])){
				$currentmenu=$keymenu;
				if(empty($valmenu[1])){$code.=$template["separator"];continue;};
				$str="";
				if(isset($_SESSION["hiddenmenu"])){
					if(strpos($_SESSION["hiddenmenu"],";".$keymenu.";")===false){
						$code.=design("<a href='".$urlsep."menustatus=".$keymenu.".0'>-</a> ".$valmenu[1],"etitle");
					}
					else{
						$codeend.=$valmenu[1]." <a href='".$urlsep."menustatus=".$keymenu.".1'>+</a>, ";
					};
				};
                continue;
            };
			if(isset($_SESSION["hiddenmenu"])){
				if(strpos($_SESSION["hiddenmenu"],";".$currentmenu.";")!==false)continue;
			};
            if(!empty($valmenu[2])){
                $info=array();
                require("modules/".$valmenu[2]);
                if(empty($info))continue;
            };
            $info["{url}"]=QueryParam(array(),1)."a=".$keymenu;
            if($lines)$code.=design(strtr($valmenu[1],$info),"line".($i%2)); else $code.=strtr($valmenu[1],$info);
            if($valmenu[1])$i++;
        };
		if($codeend)$code.=design("Скрытые разделы: ".rtrim($codeend," ,"),"info");
		return $code;
	};
    //==================================================//
	/*
	Функция выдергивания всех ссылок
	*/
    function GetLinkA(&$content,$links=array()){
        $keys=array();
        if(preg_match_all("!(<a[ \r\n\t][^>]*href[ \r\n\t]*=[ \r\n\t]*\"?'?([^ \"'>]+)\"?'?[^>]*>)!si",$content,$listurl)){
            for($j=0;$j<count($listurl[0]);$j++){
                $str=$listurl[2][$j];
                if(isset($keys[$str]))continue;
                $links[]=$str;
                $keys[$str]=1;
            };
        }
        return $links;
    };
    //==================================================//
	/*
	Преобразование урла к полному пути
	*/
    function new_abs($url,$base,$extlink=1){
        if(!is_array($base)){
            $base=parse_url(str_replace("&amp;","&",$base));
        };
		if(strpos($url,"javascript:")===0)return "";
		elseif(strcmp($url,"http://")==0)return "";
		elseif(strpos($url,"mailto:")===0)return "";
        $url=str_replace("&amp;","&",$url);
        $parseurl=@parse_url($url);//разобрать урл на куски
        //скопируем хост
        if(empty($parseurl["host"])){
            $parseurl["host"]=$base["host"];
        }
        elseif(!$extlink){//выкидывать внешние ссылки
            if(strcmp($parseurl["host"],$base["host"])!=0)return "";
        };
        //если в урле есть схема, значит он абсолютный и выходим
        if(!empty($parseurl["scheme"]))return $url;
        //скопируем схему
        $parseurl["scheme"]=$base["scheme"];
        //есть путь. нужно подправить
        if(!empty($parseurl["path"])){
            if(empty($base["path"]))$base["path"]="";
            if($parseurl["path"][0]=='/'){
                //он такой и останется
            }
            else{
                $deep=0;
                $basepath=explode("/",trim($base["path"],"/"));
                $elempath=explode("/",trim($parseurl["path"],"/"));
                $deepbase=count($basepath)-1;
                if(strpos($basepath[$deepbase],".")!==false){unset($basepath[$deepbase]);$deepbase--;}//есть файл, его удалим из пути            
                for($j=0;$j<count($elempath);$j++){
                    //print_r($basepath);
                    if(strcmp($elempath[$j],"..")==0){unset($basepath[$deepbase]);$deepbase--;continue;};
                    if(strcmp($elempath[$j],".")==0)continue;            
                    $deepbase++;$basepath[$deepbase]=$elempath[$j];
                };
                $parseurl["path"]="/".join("/",$basepath);
                if(strpos($parseurl["path"],"//")===0)$parseurl["path"]=substr($parseurl["path"],1);
            };
        }
        //не было ни каталога ни файла, поэтому скопируем базовый
        else{
            $parseurl["path"]=isset($base["path"])?$base["path"]:"/";
        };
        return $parseurl["scheme"]."://".$parseurl["host"].$parseurl["path"].(isset($parseurl["query"])?("?".$parseurl["query"]):"");
    };
    //==================================================//
	/*
	Проверка наличия ссылки
	Если $urllink пустая, то проверить только на соответствие сайта
	*/
	function CheckDirLink($urllink,$urlsite){
		$ch=curl_init($urlsite);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
		curl_setopt($ch, CURLOPT_USERAGENT, "Nokia6820/2.0 (4.83) Profile/MIDP-1.0 Configuration/CLDC-1.0"); 
		curl_setopt($ch, CURLOPT_HTTPHEADER, array("ACCEPT: text/xml,application/xml,application/xhtml+xml,text/html;q=0.9,text/plain;q=0.8,image/png,*/*;q=0.5","ACCEPT_LANGUAGE: ru","ACCEPT_CHARSET: utf-8"));
		curl_setopt($ch, CURLOPT_TIMEOUT, 30); 
		$content=curl_exec($ch);
		curl_close($ch);	
		if(empty($content)){
			return "Нет возможности загрузить информацию о сайте. Ошибка в адресе сайта или ошибка связи.";
		}
		else{
			//почистить код от мусора
			$content=preg_replace("/\<!--(.*?)--\>/si","",$content);//удалить все комментарии
			$content=preg_replace("/\<noindex>(.*?)\<\/noindex\>/si","",$content);//удалить всё, что не индексируется		
			//выдернуть ссылки
			$links=GetLinkA($content);
			$base=parse_url($urlsite);
			$ins=0;$outs=0;
			$nlinks=count($links);
			for($i=0;$i<$nlinks;$i++){
				$str=new_abs($links[$i],$base,0);
				if(!$str)$outs++; else $ins++;
			};
			/*
			if($ins==0){
				return "Сайт состоит из одной страницы или неправильно сформированы ссылки.";
			}//if($ins==0)
			else*/
			if($outs>15){
				return "На странице сайта слишком много ссылок на внешние сайты. Максимально допустимо 15 ссылок.";
			}//if($outs>$ins)
			//проверка наличия ссылка
			if($urllink){
				for($i=0;$i<$nlinks;$i++){
					if(strcmp($links[$i],$urllink)==0)return "";//ссылка найдена
				};
				return "Ссылка не найдена.";
			};
		};//else
		return "";//нормальное завершение
	};
	//==================================================//
	/*
	Вывод рекламы на сайте
	*/
    function ADV($topbid=1,$num=1){
        global $wappc3_idsite, $wappc_aff, $wappc_keyword, $ppc_other, $ppc_other_adv, $_dir, $user_agent;
		if(strpos($user_agent,"http://")!==false)return "";
		$code="";		
		//wappc.biz
		if(!empty($wappc3_idsite)){
			include_once('core/libwappc3.php');
			$code=GetFeedWAPPC3($num,array("charset"=>"utf-8","temp"=>$_dir."temp","aff"=>$wappc3_idsite,"empty"=>"","template"=>'%code%<br/>',"sep"=>'',"operator"=>1,"topbid"=>$topbid));
		};
		//wappc.ru
		if((empty($code))&&(!empty($wappc_aff))){
			include_once('core/client_wappc.php');		
			$code.=GetFeed($wappc_keyword,$num,"utf-8");
		};		
		//другая реклама
		if((empty($code))&&(!empty($ppc_other))){
			$row=$ppc_other_adv[mt_rand(0,count($ppc_other_adv)-1)];
			$code.="<a href='".$row[2]."'>".$row[3]."</a><br/>";
		};
		
		if(!empty($code))return $code;
		
    };
    //==================================================//
    /*
	Функция занесения активности модераторов
	*/
    function ModerateBonus($id_user, $bonus, $desc){
		if(isset($_SESSION[$desc]))return false;
		$filecheck="logs/moder_".$id_user.".log";
		$flag="ab";
		if(file_exists($filecheck)){
			$datacheck=file_get_contents($filecheck);
			if(strpos($datacheck,"|".$desc."|")!==false)return false;
			if(strlen($datacheck)>300)$flag="wb";
		};
		SaveLog("moderatework",$id_user."|".$bonus."|".$desc."|".(empty($_SESSION["countworkmoderate"])?0:$_SESSION["countworkmoderate"]));
		if($bonus<0){$fine=abs($bonus);$bonus=0;} else $fine=0;
        SQLquery("insert into moderatorwork set day=NOW(), id_user=".$id_user.", bonus=".$bonus.", fine=".$fine.", description='".AddSlashes($desc)."' ON DUPLICATE KEY UPDATE bonus=bonus+".$bonus.", fine=fine+".$fine.", description=concat(description,';','".AddSlashes($desc)."')");
		$_SESSION[$desc]=1;
		$fd=fopen($filecheck,$flag);fwrite($fd,time()."|".$desc."|\n");fclose($fd);
		return true;
    };
    //==================================================//
    function LockAdmin($id_user,$name,$lock=1){
        global $auth, $path_session;
        $filemoder=$path_session."/".$name.".txt";
        $moder=@file_get_contents($filemoder);
        $moderate=0;
        if($moder){
            $elem=explode("|",$moder);
            if(($elem[0]>time()-5*60)&&($elem[1]!=$auth["id_user"]))$moderate=$elem[1];
        };
        if(($lock)&&(!$moderate)){
            $fd=fopen($filemoder,"wb");
            fwrite($fd,time()."|".$auth["id_user"]);
            fclose($fd);
        };
        return $moderate;
    };
    //==================================================//
	/*
	Функция подсчета процента системы
	*/
	function CalcDinPerc($percdin_sys,$perc_system,$balance){
		if(!empty($percdin_sys)){
			$perc_system_din=$percdin_sys[0][1];
			$n=count($percdin_sys);
			for($i=$n-1;$i>0;$i--){
				if($i==0)$minprice=0; else $minprice=$percdin_sys[$i][0];
				if($balance>=$minprice){$perc_system_din=$percdin_sys[$i][1];break;};
			};
			return $perc_system_din;
		}
		else{
			return $perc_system;
		};
	};
    //==================================================//
	/*
	Функция вывода процента системы
	*/
	function ShowDinPerc($percdin_sys,$perc_system,$type=0){
		global $namecurrency;
		if(!empty($percdin_sys)){
			$str="Комиссия системы при размещении рекламы с ".($type?"ценой":"бюджетом")." менее ".$percdin_sys[1][0]." ".$namecurrency[2]." - ".round($percdin_sys[0][1]*100,2)."%";
			$nmax=count($percdin_sys)-1;
			for($i=2;$i<=$nmax;$i++){
				$str.=", от ".$percdin_sys[$i-1][0]." до ".$percdin_sys[$i][0]." ".$namecurrency[2]." - ".round($percdin_sys[$i-1][1]*100,2)."%";
			};
			$str.=", более ".$percdin_sys[$nmax][0]." ".$namecurrency[2]." - ".round($percdin_sys[$nmax][1]*100,2)."%";
			return design($str,"info");
		}
		else{
			return design("Комиссия системы ".round($perc_system*100,2)."%","info");
		};
	};//function ShowDinPerc($percdin_sys,$perc_system)
	//==================================================//
	/*
	Записать информацию, что форма уже обработана
	*/
	function FormSend($name){
		$_SESSION["_formpost"]=time();
		$_SESSION["_formpostname"]=$name;
	};
	//==================================================//
	/*
	Проверка на повторную отправку формы
	*/
	function FormIsSend($name){
		if((isset($_SESSION["_formpost"]))&&($_SESSION["_formpost"]>time()-15)&&(strcmp($_SESSION["_formpostname"],$name)==0))return true; else return false;
	};

?>