<?php
/*
Запуск по таймеру раз в сутки
Начисление реферальских
Автор: Denvas
*/
    if(!extension_loaded('curl')) {
        if(!dl('curl.so')){print "Not load curl\n";exit;};
    };
    if(!extension_loaded('mysql')) {
        if(!dl('mysql.so')){print "Not load mysql\n";exit;};
    };

    chdir(dirname(__FILE__)."/..");
    include_once("config.php");//путь до конфигурационного файла
    include_once("core/functionsql.php");
    include_once("core/money.php");
    include_once("config_modules.php");
	
	$pid=getmypid();	
    $fd_lock=fopen("temp/day.lock","w");
    if(!flock($fd_lock,LOCK_EX|LOCK_NB)){print "Locked\n";exit;};
    fwrite($fd_lock,time()."\n".$pid."\n");

    @set_time_limit(0);//выполнять без ограничений

    $day=date("Y-m-d", time());//прошлые сутки
    print $day."\n";
    $moneyadmin=0;

    SQLconnect();
	
	SQLquery("update users set moneyyesterday=0, moneyadvyesterday=0");
	
	if(empty($percdeepmasteradv))$percdeepmasteradv=0;
	//ежедневный заработок и реферальские
	$data=SQLarray("select id_user, moneytoday from users where moneytoday>0",MYSQL_ASSOC);
	$ndata=count($data);
	for($i=0;$i<$ndata;$i++){
		$row=$data[$i];
		//начиислить реферальские
		if($percdeepmasteradv<1){
			$money=$row["moneytoday"]*(1-$percdeepmasteradv);
			TransRefer($row["id_user"],$money,"реферальские");
			print "REF: ".$row["id_user"]." ".$money."\n";
		};
		//обнулить данные
		SQLquery("update users set moneyyesterday=moneytoday where id_user=".$row["id_user"]);
	};//for($i=0;$i<$ndata;$i++)
	//ежедневные траты и реферальские
	$data=SQLarray("select id_user, moneyadvtoday from users where moneyadvtoday>0",MYSQL_ASSOC);
	$ndata=count($data);
	for($i=0;$i<$ndata;$i++){
		$row=$data[$i];
		//начиислить реферальские
		if($percdeepmasteradv>0){
			$money=$row["moneyadvtoday"]*$percdeepmasteradv;
			TransRefer($row["id_user"],$money,"реферальские реклама");
			print "REFADV: ".$row["id_user"]." ".$money."\n";
		};
		//обнулить данные
		SQLquery("update users set moneyadvyesterday=moneyadvtoday where id_user=".$row["id_user"]);
	};//for($i=0;$i<$ndata;$i++)
	
	//обнулить количество заработанных сегодня денег
	SQLquery("update users set moneytoday=0, moneyadvtoday=0");
	//почистить транзакции старее месяца
	SQLquery("delete from transactions where transdate<'".date("Y-m-d", time()-30*24*60*60)."'");
	
	if(!empty($deletenotactive)){
		//очистить регистарции в которых не было входов
		SQLquery("update users set status='delete' where regdate<'".date("Y-m-d", time()-10*24*60*60)."' and timeses=0 and moneyall=0 and moneyadvall=0");
		
		//разослать предупреждения
		$oldtime=time()-53*24*60*60;
		$data=SQLarray("select id_user, email from users where status='active' and DATE_FORMAT(regdate,'%Y-%m-%d')='".date("Y-m-d", $oldtime)."' and timeses>0 and timeses<".$oldtime." and balance<30 and moneytoday+moneyyesterday+moneyadvtoday+moneyadvyesterday<0.01 and moneyrefall<0.1 order by id_user limit 0,100");
		$ndata=count($data);
		for($i=0;$i<$ndata;$i++){
			list($id_user,$email)=$data[$i];
			SendMailTemplate($email,"delete",array(TMPL."id_user".TMPL=>$id_user,TMPL."site".TMPL=>$maindomain));
		};//for($i=0;$i<$ndata;$i++)
		print "Send old mail: ".$ndata."\n";
		
		//почислить пустые регистрации
		$oldtime=time()-60*24*60*60;
		print "Delete: ".$oldtime."\n";
		$data=SQLarray("select id_user, id_parent from users where regdate<'".date("Y-m-d", $oldtime)."' and timeses<".$oldtime." and balance<30 and moneytoday+moneyyesterday+moneyadvtoday+moneyadvyesterday<0.01 and moneyrefall<0.1 order by id_user limit 0,100");
		$ndata=count($data);
		$f_links=SQLone("show tables like 'clicks_links'","");
		$f_directlinks=SQLone("show tables like 'directlink_site'","");
		$f_flow=SQLone("show tables like 'flow'","");
		$f_inmail=SQLone("show tables like 'inmail'","");
		$f_surf_links=SQLone("show tables like 'surf_links'","");
		$f_task=SQLone("show tables like 'task'","");
		$parent=array();
		for($i=0;$i<$ndata;$i++){
			$id_user=$data[$i][0];
			$parent[$data[$i][1]]=1;
			SQLquery("delete from users where id_user=".$id_user.";");
			if($f_links){
				SQLquery("delete from clicks_links where id_user=".$id_user.";");
			};
			if($f_directlinks){
				SQLquery("delete from directlink_site where id_user=".$id_user.";");
				SQLquery("update directlink_links set status='delete' where id_user=".$id_user.";");
			};
			if($f_inmail){
				SQLquery("delete from inmail where id_user=".$id_user." or id_contact=".$id_user.";");
			};
			if($f_surf_links){
				SQLquery("delete from surf_links where id_user=".$id_user.";");
			};
			if($f_task){
				SQLquery("update task set status='break' where id_user=".$id_user." and status='active';");
			};
		};//for($i=0;$i<$ndata;$i++)
		reset($parent);
		while(list($id_user,$val)=each($parent)){
			$nchild=SQLone("select count(id_user) from users where id_parent=".$id_user);
			SQLquery("update users set refcount=".$nchild." where id_user=".$id_user);
		};
		print "Delete empty: ".$ndata."\n";
	};//if(!empty($deletenotactive))
    SQLclose();
	
    $fdir=opendir("temp");
    while($name=readdir($fdir)){
        if((strpos($name,"ses_")!==0)&&(strpos($name,".tmp")===false))continue;
        unlink("temp/".$name);
    };//while($name=readdir($fdir))
    closedir($fdir);
	
    fclose($fd_lock);
    print "Ok\n";
?>