DROP TABLE IF EXISTS news;
create table news
(
    id_news int NOT NULL auto_increment,
    date datetime not null,
    news text,
    comment int default 0,
       primary key (id_news)
);
insert into news set date=NOW(), news='Мы открылись';

DROP TABLE IF EXISTS news_comments;
create table news_comments
(
    id_comment int NOT NULL auto_increment,
    id_news int not null,
    id_user int default 0,
    date datetime not null,
    message text,
       primary key (id_comment),
       key(id_news)
);
